Bug 523097 - Backporting sched fixes for desktop usage from upstream
Summary: Backporting sched fixes for desktop usage from upstream
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel
Version: 12
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: Kernel Maintainer List
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-09-14 05:12 UTC by Amit Shah
Modified: 2010-09-24 22:41 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-09-24 22:41:33 UTC


Attachments (Terms of Use)

Description Amit Shah 2009-09-14 05:12:52 UTC
Description of problem:

Upstream commits

a8fae3ec5f118dc92517dcbed3ecf69ddb641d0f
b5d9d734a53e0204aab0089079cbde2a1285a38f
2bba22c50b06abe9fd0d23933b1e64d35b419262
172e082a9111ea504ee34cbba26284a5ebdc53a7
61cbe54d9479ad98283b2dda686deae4c34b2d59
3f2aa307c4d26b4ed6509d0a79e8254c9e07e921

fix some latency problems observed during desktop usage. These are merged for 32-rc1.

Consider for backporting for F-11 and F-12.

Comment 2 Chuck Ebbert 2009-09-15 00:56:32 UTC
Commit 61cbe54d9479ad98283b2dda686deae4c34b2d59 is still being debated upstream:

http://marc.info/?t=125293587800013&r=1&w=2

Comment 4 Kyle McMartin 2009-09-15 16:39:53 UTC
I'm not sure that the first one there:
commit a8fae3ec5f118dc92517dcbed3ecf69ddb641d0f
Author: Peter Zijlstra <a.p.zijlstra@chello.nl>
Date:   Mon Sep 7 18:32:32 2009 +0200

    sched: enable SD_WAKE_IDLE
    
    Now that SD_WAKE_IDLE doesn't make pipe-test suck anymore,
    enable it by default for MC, CPU and NUMA domains.
    
    Signed-off-by: Peter Zijlstra <a.p.zijlstra@chello.nl>
    LKML-Reference: <new-submission>
    Signed-off-by: Ingo Molnar <mingo@elte.hu>

Is appropriate without the pipe changes described therein.

Comment 5 Kyle McMartin 2009-09-15 17:01:03 UTC
http://koji.fedoraproject.org/koji/taskinfo?taskID=1680905 dist-f12
http://koji.fedoraproject.org/koji/taskinfo?taskID=1680915 dist-f11

scratch builds for your pleasure.

Comment 6 Amit Shah 2009-09-16 09:54:21 UTC
(In reply to comment #4)
> I'm not sure that the first one there:
> commit a8fae3ec5f118dc92517dcbed3ecf69ddb641d0f
...
> Is appropriate without the pipe changes described therein.  

Right; two previous commits:

cdd2ab3de4301728b20efd6225681d3ff591a938
71a29aa7b600595d0ef373ea605ac656876d1f2f

would be necessary.

Also these two commits are directed towards better results:

47734f89be0614b5acbd6a532390f9c72f019648
840a0653100dbde599ae8ddf83fa214dfa5fd1aa

http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commitdiff_plain;h=cdd2ab3de4301728b20efd6225681d3ff591a938

http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commitdiff_plain;h=71a29aa7b600595d0ef373ea605ac656876d1f2f

http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commitdiff_plain;h=47734f89be0614b5acbd6a532390f9c72f019648

http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commitdiff_plain;h=840a0653100dbde599ae8ddf83fa214dfa5fd1aa

Comment 7 Amit Shah 2009-09-18 05:44:45 UTC
I've been trying out the x86_64 kernel that Kyle has built. It's working fine since a couple of days (X crashes if compiz enabled; but it could be something unrelated -- haven't tested yet)

The sched code, meanwhile, is seeing a lot of activity. Better to track it from these two git trees:

the devel or staging tree:

http://git.kernel.org/?p=linux/kernel/git/mingo/linux-2.6-sched-devel.git;a=shortlog;h=sched/core

the branch that's fed to Linus:

http://git.kernel.org/?p=linux/kernel/git/mingo/linux-2.6-sched-devel.git;a=shortlog;h=sched-core-for-linus

There are a lot more patches there than the ones mentioned here.

Comment 8 Chuck Ebbert 2009-09-27 09:53:11 UTC
(In reply to comment #7)
 
> The sched code, meanwhile, is seeing a lot of activity.

Someone needs to pick out the obvious fixes from that mess.

I've made a try in 2.6.30.8-67.fc11 by putting in these patches:

sched-deal-with-low-load-in-wake-affine.patch
sched-disable-NEW-FAIR-SLEEPERS-for-now.patch
sched-ensure-child-cant-gain-time-over-its-parent-after-fork.patch
sched-remove-shortcut-from-select-task-rq-fair.patch
sched-retune-scheduler-latency-defaults.patch

Comment 9 Amit Shah 2009-10-01 05:26:31 UTC
A couple more commits yesterday --

commit 79e1dd05d1a22e95ab6d54d21836f478b3b56976
Author: Arjan van de Ven <arjan@infradead.org>
Date:   Wed Sep 30 17:07:54 2009 +0200

    x86: Provide an alternative() based cmpxchg64()

commit 152f9d0710a62708710161bce1b29fa8292c8c11
Author: Eric Dumazet <eric.dumazet@gmail.com>
Date:   Wed Sep 30 20:36:19 2009 +0200

    sched_clock: Fix atomicity/continuity bug by using cmpxchg64()
    
    Commit def0a9b2573 (sched_clock: Make it NMI safe) assumed
    cmpxchg() of 64bit values was available on X86_32.
    
    That is not so - and causes some subtle scheduler misbehavior due
    to incorrect timestamps off to up by ~4 seconds.
    
    Two symptoms are known right now:
    
     - interactivity problems seen by Arjan: up to 600 msecs
       latencies instead of the expected 20-40 msecs. These
       latencies are very visible on the desktop.
    
     - incorrect CPU stats: occasionally too high percentages in 'top',
       and crazy CPU usage stats.

Comment 10 Bug Zapper 2009-11-16 12:20:40 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 11 Stanislaw Gruszka 2010-09-24 22:41:33 UTC
I think this was fixed long time ago, but if not should be fixed as WONTFIX anyway.


Note You need to log in before you can comment on or make changes to this bug.